#!/usr/bin/perl

require "wf_read_cookie_data.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";

#--- read form values manually to handle the check boxes

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$dcount = -1;
$fcount = -1;
#$totalsz = 0;

foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  if($name eq "chk_folder")
   {$FOLDERS[++$dcount] = $value;}
  elsif($name eq "chk_file")
   {$FILES[++$fcount] = $value;}
  else
   {$FORM{$name} = $value;}
 }

#--- read cookies

&wf_read_cookie_data();

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";$FORM{cwd} = "~";}

if($FORM{action} eq "")
  {$error = 1;$errmsg = "ACTION cannot be empty.";}

if($FORM{action} eq "delete")
  {
    $action_desc = "Delete";
    $onloadscript = "onload=document.list_handler.submit()";
    $showbanner = "";
   }
elsif($FORM{action} eq "chmod")
  {
    $action_desc = "Chmod";
    $onloadscript = "onload=document.list_handler.submit()";
    $showbanner = "";
   }
elsif($FORM{action} eq "rmdir")
  {
    $action_desc = "Remove Directory";
    $onloadscript = "onload=document.list_handler.submit()";
    $showbanner = "";
  }
elsif($FORM{action} eq "rename")
  {
    $action_desc = "Rename";
    $showbanner = "1";
  }
elsif($FORM{action} eq "download")
  {
    $action_desc = "Downloading";
    $onloadscript = "onload=HandleDownload()";
    $showbanner = "";
  }
else
  {$error = 1;$errmsg = "Invalid ACTION value.";}

if($fcount >= 0 and $FORM{action} eq "rmdir")
  {$error = 1;$errmsg = "Files cannot be 'Removed', delete them using 'Delete'.<br>Please select only directories.";}

if($dcount < 0 and $FORM{action} eq "rmdir")
  {$error = 1;$errmsg = "Please select some directories using the check boxes beside the name.";}

if(($dcount < 0 and $fcount < 0) and ($FORM{action} eq "rename" or $FORM{action} eq "download" or $FORM{action} eq "delete"))
  {$error = 1;$errmsg = "Please select some files/directories using the check boxes beside the name.";}

if($error != 0)
  {&wf_print_message($errmsg."<br><br><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>Continue</a>",$FORM{servername},$FORM{user_id});exit;}

#--- confirmation

$ffcount = $fcount + 1;
$ddcount = $dcount + 1;

if($FORM{action} ne "download" and $FORM{action} ne "delete" and $FORM{action} ne "rmdir" and $FORM{action} ne "chmod")
 {
  &wf_print_header("SmoothFTP > $action_desc",$FORM{servername},"<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>$FORM{cwd}</a>","$FORM{user_id}",0,$onloadscript);
  print "<p align=center><strong><font color=#0080C0 size=4>$action_desc</font></strong></p>";
 }
else
 {
  print "Content-type: text/html\n\n";
  print "<html><head><title></title></head><body $onloadscript>\n";
 }

if($FORM{action} eq "delete")
 {
  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_delete.cgi method=post>";
  for($i = 0;$i <= $dcount;$i++)
   {print "<input type=hidden name=dname value=$FOLDERS[$i]>";}
  for($i = 0;$i <= $fcount;$i++)
   {print "<input type=hidden name=name value=$FILES[$i]>";}
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</form>";
 }
elsif($FORM{action} eq "chmod")
 {
  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_chmod_get.cgi method=post>";
  print "<input type=hidden name=name value=$FILES[0]>";
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</form>";
 }
elsif($FORM{action} eq "rmdir")
 {
  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_rmdir.cgi method=post>";
  for($i = 0;$i <= $dcount;$i++)
   { print "<input type=hidden name=name value=$FOLDERS[$i]>";}
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</form>";
 }
elsif($FORM{action} eq "rename")
 {
  print "<center><font size=1>(Note: You can move files on the server by";
  print "specifying a path in the new name.<br>";
  print "For ex. rename abc.txt to newdir/abc.txt)</center><br>";

  print "<form action=/cgi-bin/smoothftp/wf_rename.cgi method=post>";
  print "<table align=center border=0 cellspacing=1 cellpadding=3>";

  print "<tr>";
  print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
  print "<td bgcolor=#EEEEEE><strong>New name</strong></td>";
  print "</tr>";

  for($i = 0;$i <= $dcount;$i++)
   {
    print "<tr>";
    print "<td><img src=/images/folder.gif width=13 height=12>&nbsp;$FOLDERS[$i]";
    print "<input type=hidden name=name value=$FOLDERS[$i]></td>";
    print "<td><input type=textbox name=new_name size=20 maxlength=50 value=$FOLDERS[$i]></td>";
    print "</tr>";
   }

  for($i = 0;$i <= $fcount;$i++)
   {
    print "<tr>";
    print "<td><img src=/images/file.gif width=13 height=12>&nbsp;$FILES[$i]";
    print "<input type=hidden name=name value=$FILES[$i]></td>";
    print "<td><input type=textbox name=new_name size=20 maxlength=50 value=$FILES[$i]></td>";
    print "</tr>";
   }

  print "<tr><td align=center colspan=2>";
  print "<input type=submit style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=ok value=Rename>&nbsp;&nbsp;&nbsp;";
  print "<input type=button style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=cancel value=Cancel onclick=\"javascript:window.location.href=\'/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\'\">";
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</td></tr>";
  print "</table>";
  print "</form>";
 }
elsif($FORM{action} eq "download")
 {
  $ffcount = "";
  $ffcount = " " . ($fcount+1) . " files" if($fcount >= 0);

  $ddcount = "";
  $ddcount = " " . ($dcount+1) . " directories" if($dcount >= 0);
   
  print "\n<script language=\"JavaScript\">\n";
  print "<!--- \n";
  print "  function HandleDownload()\n";
  print "   {\n";
  print "     msgWindow=window.open(\"/dnloading.htm\",\"displayWindow\",\"width=300,height=150\");\n";
  print "     document.list_handler.submit();\n";
  print "   }\n";
  print "//-->\n";
  print "</script>\n";

  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_download.cgi method=post>";
#  print "<iframe marginwidth=0 marginheight=0 frameborder=0 scrolling=no align=center width=100% src=\"http://www.denish.net/denishadlong.swf\" style='border:none'></iframe>";
#  print "<p align=center><b>Please be patient, preparing to download" . $ffcount . $ddcount . "...</b></p>\n";
  for($i = 0;$i <= $dcount;$i++)
   {print "<input type=hidden name=dname value=$FOLDERS[$i]>";}
  for($i = 0;$i <= $fcount;$i++)
   {print "<input type=hidden name=name value=$FILES[$i]>";}
  print "<input type=hidden name=cwd value=$FORM{cwd}>\n";
  print "</form>";
 }

&wf_print_footer($showbanner) if($FORM{action} ne "delete" and $FORM{action} ne "rmdir" and $FORM{action} ne "chmod" and $FORM{action} ne "download");

#--- end
