#!/usr/bin/perl

require "wf_read_cookie_data.cgi";
require "wf_print_header.cgi";
require "wf_print_footer.cgi";
require "wf_print_message.cgi";
require "wf_connect.cgi";

#--- read form values manually to handle the check boxes

$input_length = $ENV{CONTENT_LENGTH};

if($input_length ==  0)
 {$buffer=$ENV{QUERY_STRING};}
else
 {read(STDIN,$buffer,$input_length);}

@variables = split(/&/,$buffer);

$dcount = -1;
$fcount = -1;
#$totalsz = 0;
$dmcount = -1;
$fmcount = -1;

foreach $variable(@variables)
 {
  ($name,$value) = split(/=/,$variable);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
  if($name eq "chk_folder")
   {$FOLDERS[++$dcount] = $value;}
  elsif($name eq "chk_file")
   {$FILES[++$fcount] = $value;}
  elsif($name eq "dmode")
   {$DDMODE[++$dmcount] = $value;}
  elsif($name eq "fmode")
   {$FFMODE[++$fmcount] = $value;}
  else
   {$FORM{$name} = $value;}
 }

for($x = 0;$x <= $dcount;$x++)
 {$DMODE[$x] = "";}

for($x = 0;$x <= $fcount;$x++)
 {$FMODE[$x] = "";}

for($x = 0;$x <= $dmcount;$x++)
 {
  ($nm, $attr) = split(/~/,$DDMODE[$x]);
  for($j = 0;$j <= $dcount;$j++)
   {
    if($nm eq $FOLDERS[$j])
     {
      $DMODE[$j] = $attr;
      $j = $dcount + 1;
     }
   }
 }

for($x = 0;$x <= $fmcount;$x++)
 {
  ($nm, $attr) = split(/~/,$FFMODE[$x]);
  for($j = 0;$j <= $fcount;$j++)
   {
    if($nm eq $FILES[$j])
     {
      $FMODE[$j] = $attr;
      $j = $fcount + 1;
     }
   }
 }

$totcont = $fcount + $dcount + 2;

$ffstr = "files/dirs" if($fcount > -1 and $dcount > -1);
$ffstr = "files" if($fcount > -1 and $dcount == -1);
$ffstr = "dirs" if($fcount == -1 and $dcount > -1);

$ffstr2 = "file/dir" if($fcount > -1 and $dcount > -1);
$ffstr2 = "file" if($fcount > -1 and $dcount == -1);
$ffstr2 = "dir" if($fcount == -1 and $dcount > -1);

#--- read cookies

&wf_read_cookie_data();

#--- error handling

if($FORM{cwd} eq "")
  {$error = 1;$errmsg = "CWD cannot be empty";$FORM{cwd} = "~";}

if($FORM{action} eq "")
  {$error = 1;$errmsg = "ACTION cannot be empty.";}

if($FORM{action} eq "delete")
  {
    $action_desc = "Delete";
    $onloadscript = "onload=document.list_handler.submit()";
    $showbanner = "";
   }
elsif($FORM{action} eq "rmdir")
  {
    $action_desc = "Remove Directory";
    $onloadscript = "onload=document.list_handler.submit()";
    $showbanner = "";
  }
elsif($FORM{action} eq "rename")
  {
    $action_desc = "Rename";
    $showbanner = "1";
  }
elsif($FORM{action} eq "chmod")
  {
    $action_desc = "Chmod";
    $showbanner = "1";
  }
elsif($FORM{action} eq "download")
  {
    $action_desc = "Downloading";
    $onloadscript = "onload=HandleDownload()";
    $showbanner = "";
  }
else
  {$error = 1;$errmsg = "Invalid ACTION value.";}

if($fcount >= 0 and $FORM{action} eq "rmdir")
  {$error = 1;$errmsg = "Files cannot be 'Removed', delete them using 'Delete'.<br>Please select only directories.";}

if($dcount < 0 and $FORM{action} eq "rmdir")
  {$error = 1;$errmsg = "Please select some directories using the check boxes beside the name.";}

if(($dcount < 0 and $fcount < 0) and ($FORM{action} eq "rename" or $FORM{action} eq "download" or $FORM{action} eq "delete" or $FORM{action} eq "chmod"))
  {$error = 1;$errmsg = "Please select some files/directories using the check boxes beside the name.";}

if($error != 0)
  {&wf_print_message($errmsg."<br><br><a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>Continue</a>",$FORM{servername},$FORM{user_id});exit;}

#--- confirmation

$ffcount = $fcount + 1;
$ddcount = $dcount + 1;

if($FORM{action} ne "download" and $FORM{action} ne "delete" and $FORM{action} ne "rmdir")
 {
  &wf_print_header("SmoothFTP > $action_desc",$FORM{servername},"<a href=/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}>$FORM{cwd}</a>","$FORM{user_id}",0,$onloadscript);
  print "<p align=center><strong><font color=#0080C0 size=4>$action_desc</font></strong></p>";
 }
else
 {
  print "Content-type: text/html\n\n";
  print "<html><head><title>SmoothFTP > Processing</title></head><body $onloadscript>\n";
  print "<br><br><center><font face=\"arial, helvetica, sans-serif\" size=2>Please wait...</font></center>";
 }

if($FORM{action} eq "delete")
 {
  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_delete.cgi method=post>";
  for($i = 0;$i <= $dcount;$i++)
   {print "<input type=hidden name=dname value=$FOLDERS[$i]>";}
  for($i = 0;$i <= $fcount;$i++)
   {print "<input type=hidden name=name value=$FILES[$i]>";}
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</form>";
 }
elsif($FORM{action} eq "chmod")
 {
  print <<EOF if($totcont > 1);

<script language=javascript>
<!--

function doall()
 {
  document.list_handler.chmodtype.value = "all";
  document.list_handler.submit();
 }

function doone()
 {
  document.list_handler.chmodtype.value = "each";
  document.list_handler.submit();
 }

function check_mode()
  {

             if(document.list_handler.mode[0].value.length == 0 || 
                document.list_handler.mode[0].value == "000")
              {
               if(confirm("Are you sure you want to set permissions to 000?"))
                {
                 document.list_handler.chmodtype.value = "all";
                 document.list_handler.submit();
                }
              }
             else
                {
                 document.list_handler.chmodtype.value = "all";
                 document.list_handler.submit();
                }
  }

function handle_chmod(which)
 {
  mode = document.list_handler.mode[which].value;

  document.list_handler.ur[which].checked = false;
  document.list_handler.uw[which].checked = false;
  document.list_handler.ux[which].checked = false;

  md = mode.charAt(0);
  md = (md - 2) + 2; //convert to number

  if(md > 7 || md < 0)
   {
    alert("Invalid user mode '" + md + "'. Assuming 0.");
    md = 0;
   }

  if(md >= 4)
   {
    document.list_handler.ur[which].checked = true;
    md -= 4;    
   }
  if(md >= 2)
   {
    document.list_handler.uw[which].checked = true;
    md -= 2;
   }
  if(md >= 1)
   {
    document.list_handler.ux[which].checked = true;
    md -= 1;
   }

  document.list_handler.gr[which].checked = false;
  document.list_handler.gw[which].checked = false;
  document.list_handler.gx[which].checked = false;

  md = mode.charAt(1);
  md = (md - 2) + 2; //convert to number

  if(md > 7 || md < 0)
   {
    alert("Invalid group mode '" + md + "'. Assuming 0.");
    md = 0;
   }

  if(md >= 4)
   {
    document.list_handler.gr[which].checked = true;
    md -= 4;
   }
  if(md >= 2)
   {
    document.list_handler.gw[which].checked = true;
    md -= 2;
   }
  if(md >= 1)
   {
    document.list_handler.gx[which].checked = true;
    md -= 1;
   }

  document.list_handler.or[which].checked = false;
  document.list_handler.ow[which].checked = false;
  document.list_handler.ox[which].checked = false;

  md = mode.charAt(2);
  md = (md - 2) + 2; //convert to number

  if(md > 7 || md < 0)
   {
    alert("Invalid user mode '" + md + "'. Assuming 0.");
    md = 0;
   }

  if(md >= 4)
   {
    document.list_handler.or[which].checked = true;
    md -= 4;
   }
  if(md >= 2)
   {
    document.list_handler.ow[which].checked = true;
    md -= 2;
   }
  if(md >= 1)
   {
    document.list_handler.ox[which].checked = true;
    md -= 1;
   }
 }

function handle_chkbox(which)
 {
  ur = document.list_handler.ur[which].checked;
  uw = document.list_handler.uw[which].checked;
  ux = document.list_handler.ux[which].checked;

  gr = document.list_handler.gr[which].checked;
  gw = document.list_handler.gw[which].checked;
  gx = document.list_handler.gx[which].checked;
  
  or = document.list_handler.or[which].checked;
  ow = document.list_handler.ow[which].checked;
  ox = document.list_handler.ox[which].checked;

  chmod1 = 0;

  if(ur)
   {chmod1 += 4;}

  if(uw)
   {chmod1 += 2;}

  if(ux)
   {chmod1 += 1;}

  chmod2 = 0;

  if(gr)
   {chmod2 += 4;}

  if(gw)
   {chmod2 += 2;}

  if(gx)
   {chmod2 += 1;}

  chmod3 = 0;

  if(or)
   {chmod3 += 4;}

  if(ow)
   {chmod3 += 2;}

  if(ox)
   {chmod3 += 1;}

  document.list_handler.mode[which].value = "" + chmod1 + "" + chmod2 + "" + chmod3;  
 }

// -->
</script>


EOF

  print <<EOF if($totcont == 1);

<script language=javascript>
<!--

function doall()
 {
  document.list_handler.chmodtype.value = "all";
  document.list_handler.submit();
 }

function doone()
 {
  document.list_handler.chmodtype.value = "each";
  document.list_handler.submit();
 }

function handle_chmod(which)
 {
  mode = document.list_handler.mode.value;

  document.list_handler.ur.checked = false;
  document.list_handler.uw.checked = false;
  document.list_handler.ux.checked = false;

  md = mode.charAt(0);
  md = (md - 2) + 2; //convert to number

  if(md > 7 || md < 0)
   {
    alert("Invalid user mode '" + md + "'. Assuming 0.");
    md = 0;
   }

  if(md >= 4)
   {
    document.list_handler.ur.checked = true;
    md -= 4;    
   }
  if(md >= 2)
   {
    document.list_handler.uw.checked = true;
    md -= 2;
   }
  if(md >= 1)
   {
    document.list_handler.ux.checked = true;
    md -= 1;
   }

  document.list_handler.gr.checked = false;
  document.list_handler.gw.checked = false;
  document.list_handler.gx.checked = false;

  md = mode.charAt(1);
  md = (md - 2) + 2; //convert to number

  if(md > 7 || md < 0)
   {
    alert("Invalid group mode '" + md + "'. Assuming 0.");
    md = 0;
   }

  if(md >= 4)
   {
    document.list_handler.gr.checked = true;
    md -= 4;
   }
  if(md >= 2)
   {
    document.list_handler.gw.checked = true;
    md -= 2;
   }
  if(md >= 1)
   {
    document.list_handler.gx.checked = true;
    md -= 1;
   }

  document.list_handler.or.checked = false;
  document.list_handler.ow.checked = false;
  document.list_handler.ox.checked = false;

  md = mode.charAt(2);
  md = (md - 2) + 2; //convert to number

  if(md > 7 || md < 0)
   {
    alert("Invalid user mode '" + md + "'. Assuming 0.");
    md = 0;
   }

  if(md >= 4)
   {
    document.list_handler.or.checked = true;
    md -= 4;
   }
  if(md >= 2)
   {
    document.list_handler.ow.checked = true;
    md -= 2;
   }
  if(md >= 1)
   {
    document.list_handler.ox.checked = true;
    md -= 1;
   }
 }

function handle_chkbox(which)
 {
  ur = document.list_handler.ur.checked;
  uw = document.list_handler.uw.checked;
  ux = document.list_handler.ux.checked;

  gr = document.list_handler.gr.checked;
  gw = document.list_handler.gw.checked;
  gx = document.list_handler.gx.checked;
  
  or = document.list_handler.or.checked;
  ow = document.list_handler.ow.checked;
  ox = document.list_handler.ox.checked;

  chmod1 = 0;

  if(ur)
   {chmod1 += 4;}

  if(uw)
   {chmod1 += 2;}

  if(ux)
   {chmod1 += 1;}

  chmod2 = 0;

  if(gr)
   {chmod2 += 4;}

  if(gw)
   {chmod2 += 2;}

  if(gx)
   {chmod2 += 1;}

  chmod3 = 0;

  if(or)
   {chmod3 += 4;}

  if(ow)
   {chmod3 += 2;}

  if(ox)
   {chmod3 += 1;}

  document.list_handler.mode.value = "" + chmod1 + "" + chmod2 + "" + chmod3;  
 }

// -->
</script>


EOF

  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_chmod.cgi method=post>";
  print "<table align=center border=0 cellspacing=1 cellpadding=3>";

  $crow = 0;
  if($totcont > 1)
   {
    print "<tr>";
    print "<td colspan=5>";
    print "Change the mode of ALL selected $ffstr:";
    print "</td>";
    print "</tr>";

    print "<tr>";
    print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
    print "<td bgcolor=#EEEEEE><strong>Mode</strong></td>";
    print "<td bgcolor=#EEEEEE align=center><strong>User<br>R W X</strong></td>";
    print "<td bgcolor=#EEEEEE align=center><strong>Group<br>R W X</strong></td>";
    print "<td bgcolor=#EEEEEE align=center><strong>Other<br>R W X</strong></td>";
    print "</tr>";

    print "<tr>";
    print "<td>$totcont $ffstr</td>";
    print "<input type=hidden name=name value=all></td>";
    print "<td><input type=textbox name=mode size=3 maxlength=3 value=\"000\" onblur=\"handle_chmod(0);\">";
    print "<input type=hidden name=type value=X></td>";

    print "<td>";
    print "<input type=checkbox name=ur onclick=\"handle_chkbox(0);\">";
    print "<input type=checkbox name=uw onclick=\"handle_chkbox(0);\">";
    print "<input type=checkbox name=ux onclick=\"handle_chkbox(0);\">";
    print "</td>";

    print "<td>";
    print "<input type=checkbox name=gr onclick=\"handle_chkbox(0);\">";
    print "<input type=checkbox name=gw onclick=\"handle_chkbox(0);\">";
    print "<input type=checkbox name=gx onclick=\"handle_chkbox(0);\">";
    print "</td>";

    print "<td>";
    print "<input type=checkbox name=or onclick=\"handle_chkbox(0);\">";
    print "<input type=checkbox name=ow onclick=\"handle_chkbox(0);\">";
    print "<input type=checkbox name=ox onclick=\"handle_chkbox(0);\">";
    print "</td>";

    print "<tr><td align=center colspan=5>";
#    if($dcount < 0)
#     {
#      print "<input type=hidden name=recursive value=off>";
#     }
#    else
#     {
#      print "<input type=checkbox name=recursive>Apply recursively to all selected dirs<br><br>";
#     }
    print "<input type=button style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=ok value=\"Change all\" onclick=check_mode();>&nbsp;&nbsp;&nbsp;";
    print "<input type=button style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=cancel value=Cancel onclick=\"javascript:window.location.href=\'/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\'\">";
    print "<input type=hidden name=cwd value=$FORM{cwd}>";
    print "</td></tr>";

    print "<tr>";
    print "<td colspan=6>";
    print "<br><br>OR<br><br>";
    print "Change the mode of EACH selected $ffstr2 separately: ";
    print "</td>";
    print "</tr>";

    $crow++;
   }

  print "<input type=hidden name=chmodtype value=each>";

  print "<tr>";
  print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
  print "<td bgcolor=#EEEEEE><strong>Mode</strong></td>";
  print "<td bgcolor=#EEEEEE align=center><strong>User<br>R W X</strong></td>";
  print "<td bgcolor=#EEEEEE align=center><strong>Group<br>R W X</strong></td>";
  print "<td bgcolor=#EEEEEE align=center><strong>Other<br>R W X</strong></td>";
  print "</tr>";

  for($i = 0;$i <= $dcount;$i++)
   {
    print "<tr>";
    print "<td><img src=/images/folder.gif width=13 height=12>&nbsp;$FOLDERS[$i]";
    print "<input type=hidden name=name value=$FOLDERS[$i]>";
    print "<input type=hidden name=type value=D></td>";

    $urv = "";
    $uwv = "";
    $uxv = "";
    $grv = "";
    $gwv = "";
    $gxv = "";
    $orv = "";
    $owv = "";
    $oxv = "";

    $chmod1 = 0;

    if(substr($DMODE[$i],1,1) eq "r")
      {
       $urv = "checked";
       $chmod1 += 4;
      }

    if(substr($DMODE[$i],2,1) eq "w")
      {
       $uwv = "checked";
       $chmod1 += 2;
      }

    if(substr($DMODE[$i],3,1) eq "x")
      {
       $uxv = "checked";
       $chmod1 += 1;
      }

    $chmod2 = 0;

    if(substr($DMODE[$i],4,1) eq "r")
      {
       $grv = "checked";
       $chmod2 += 4;
      }

    if(substr($DMODE[$i],5,1) eq "w")
      {
       $gwv = "checked";
       $chmod2 += 2;
      }

    if(substr($DMODE[$i],6,1) eq "x")
      {
       $gxv = "checked";
       $chmod2 += 1;
      }

    $chmod3 = 0;

    if(substr($DMODE[$i],7,1) eq "r")
      {
       $orv = "checked";
       $chmod3 += 4;
      }

    if(substr($DMODE[$i],8,1) eq "w")
      {
       $owv = "checked";
       $chmod3 += 2;
      }

    if(substr($DMODE[$i],9,1) eq "x")
      {
       $oxv = "checked";
       $chmod3 += 1;
      }

    print "<td><input type=textbox name=mode value=$chmod1$chmod2$chmod3 size=3 maxlength=3 onblur=\"handle_chmod($crow);\"></td>";

    print "<td>";
    print "<input type=checkbox name=ur $urv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=uw $uwv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=ux $uxv onclick=\"handle_chkbox($crow);\">";
    print "</td>";
  
    print "<td>";
    print "<input type=checkbox name=gr $grv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=gw $gwv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=gx $gxv onclick=\"handle_chkbox($crow);\">";
    print "</td>";

    print "<td>";
    print "<input type=checkbox name=or $orv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=ow $owv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=ox $oxv onclick=\"handle_chkbox($crow);\">";
    print "</td>";

    print "</tr>";

    $crow++;
   }

  for($i = 0;$i <= $fcount;$i++)
   {
    print "<tr>";
    print "<td><img src=/images/file.gif width=13 height=12>&nbsp;$FILES[$i]";
    print "<input type=hidden name=name value=$FILES[$i]>";
    print "<input type=hidden name=type value=F></td>";

    $urv = "";
    $uwv = "";
    $uxv = "";
    $grv = "";
    $gwv = "";
    $gxv = "";
    $orv = "";
    $owv = "";
    $oxv = "";

    $chmod1 = 0;

    if(substr($FMODE[$i],1,1) eq "r")
      {
       $urv = "checked";
       $chmod1 += 4;
      }

    if(substr($FMODE[$i],2,1) eq "w")
      {
       $uwv = "checked";
       $chmod1 += 2;
      }

    if(substr($FMODE[$i],3,1) eq "x")
      {
       $uxv = "checked";
       $chmod1 += 1;
      }

    $chmod2 = 0;

    if(substr($FMODE[$i],4,1) eq "r")
      {
       $grv = "checked";
       $chmod2 += 4;
      }

    if(substr($FMODE[$i],5,1) eq "w")
      {
       $gwv = "checked";
       $chmod2 += 2;
      }

    if(substr($FMODE[$i],6,1) eq "x")
      {
       $gxv = "checked";
       $chmod2 += 1;
      }

    $chmod3 = 0;

    if(substr($FMODE[$i],7,1) eq "r")
      {
       $orv = "checked";
       $chmod3 += 4;
      }

    if(substr($FMODE[$i],8,1) eq "w")
      {
       $owv = "checked";
       $chmod3 += 2;
      }

    if(substr($FMODE[$i],9,1) eq "x")
      {
       $oxv = "checked";
       $chmod3 += 1;
      }

    print "<td><input type=textbox name=mode value=$chmod1$chmod2$chmod3 size=3 maxlength=3 onblur=\"handle_chmod($crow);\"></td>";

    print "<td>";
    print "<input type=checkbox name=ur $urv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=uw $uwv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=ux $uxv onclick=\"handle_chkbox($crow);\">";
    print "</td>";

    print "<td>";
    print "<input type=checkbox name=gr $grv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=gw $gwv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=gx $gxv onclick=\"handle_chkbox($crow);\">";
    print "</td>";

    print "<td>";
    print "<input type=checkbox name=or $orv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=ow $owv onclick=\"handle_chkbox($crow);\">";
    print "<input type=checkbox name=ox $oxv onclick=\"handle_chkbox($crow);\">";
    print "</td>";

    print "</tr>";

    $crow++;
   }

  print "<tr><td align=center colspan=5>";

  if($totcont == 1 and $dcount == 0)
   {
      print "<input type=checkbox name=recursive>Apply recursively<br><br>";
   }

  print "<input type=submit style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=ok value=\"Change\">&nbsp;&nbsp;&nbsp;";
  print "<input type=button style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=cancel value=Cancel onclick=\"javascript:window.location.href=\'/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\'\">";
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</td></tr>";
  print "</table>";
  print "</form>";
 }
elsif($FORM{action} eq "rmdir")
 {
  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_rmdir.cgi method=post>";
  for($i = 0;$i <= $dcount;$i++)
   { print "<input type=hidden name=name value=$FOLDERS[$i]>";}
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</form>";
 }
elsif($FORM{action} eq "rename")
 {
  print "<center><font size=1>(Note: You can move files on the server by";
  print "specifying a different path in the new name.<br>";
  print "For ex. rename abc.txt to newdir/abc.txt)</center><br>";

  print "<form action=/cgi-bin/smoothftp/wf_rename.cgi method=post>";
  print "<table align=center border=0 cellspacing=1 cellpadding=3>";

  print "<tr>";
  print "<td bgcolor=#EEEEEE><strong>Name</strong></td>";
  print "<td bgcolor=#EEEEEE><strong>New name</strong></td>";
  print "</tr>";

  for($i = 0;$i <= $dcount;$i++)
   {
    print "<tr>";
    print "<td><img src=/images/folder.gif width=13 height=12>&nbsp;$FOLDERS[$i]";
    print "<input type=hidden name=name value=$FOLDERS[$i]></td>";
    print "<td><input type=textbox name=new_name size=20 maxlength=50 value=$FOLDERS[$i]></td>";
    print "</tr>";
   }

  for($i = 0;$i <= $fcount;$i++)
   {
    print "<tr>";
    print "<td><img src=/images/file.gif width=13 height=12>&nbsp;$FILES[$i]";
    print "<input type=hidden name=name value=$FILES[$i]></td>";
    print "<td><input type=textbox name=new_name size=20 maxlength=50 value=$FILES[$i]></td>";
    print "</tr>";
   }

  print "<tr><td align=center colspan=2>";
  print "<input type=submit style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=ok value=Rename>&nbsp;&nbsp;&nbsp;";
  print "<input type=button style=\"font-family: arial, helvetica,sans-serif; font-size: 9pt; font-weight: bold; color: white; background-color: #0080C0;\" name=cancel value=Cancel onclick=\"javascript:window.location.href=\'/cgi-bin/smoothftp/wf_list.cgi?cd=$FORM{cwd}\'\">";
  print "<input type=hidden name=cwd value=$FORM{cwd}>";
  print "</td></tr>";
  print "</table>";
  print "</form>";
 }
elsif($FORM{action} eq "download")
 {
  $ffcount = "";
  $ffcount = " " . ($fcount+1) . " files" if($fcount >= 0);

  $ddcount = "";
  $ddcount = " " . ($dcount+1) . " directories" if($dcount >= 0);
   
  print "\n<script language=\"JavaScript\">\n";
  print "<!--- \n";
  print "  function HandleDownload()\n";
  print "   {\n";
  print "     msgWindow=window.open(\"/dnloading.htm\",\"displayWindow\",\"width=300,height=150\");\n";
  print "     document.list_handler.submit();\n";
  print "   }\n";
  print "//-->\n";
  print "</script>\n";

  print "<form name=list_handler action=/cgi-bin/smoothftp/wf_download.cgi method=post>";
#  print "<iframe marginwidth=0 marginheight=0 frameborder=0 scrolling=no align=center width=100% src=\"http://www.denish.net/denishadlong.swf\" style='border:none'></iframe>";
#  print "<p align=center><b>Please be patient, preparing to download" . $ffcount . $ddcount . "...</b></p>\n";
  for($i = 0;$i <= $dcount;$i++)
   {print "<input type=hidden name=dname value=$FOLDERS[$i]>";}
  for($i = 0;$i <= $fcount;$i++)
   {print "<input type=hidden name=name value=$FILES[$i]>";}
  print "<input type=hidden name=cwd value=$FORM{cwd}>\n";
  print "</form>";
 }

&wf_print_footer($showbanner) if($FORM{action} ne "delete" and $FORM{action} ne "rmdir" and $FORM{action} ne "download");

#--- end
