# pslib-linux.pl - Process handling subroutines for Linux
# This file is part of Syrine 0.1b
# Copyright (C) 1997,1998  Yoram Last (ylast@mindless.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

sub RshPs { # Returns a list of currently running processes.

  return `ps lwx`;
}

sub RshKill { # Terminates a process.

  local($pid) = @_;
  $! = 0;
  if (($pid =~ m/^\d+$/) && (kill 9, $pid)) {
    return "Process $pid was terminated\n";
  } else {
    return "Can\'t kill process $pid \: $!\n";
  };
}

sub GetKillList { # Creates three equal-length arrays (@kname,@kpid,@lkill) containing names,
                  # PIDs, and url-encoded kill commands for currently running processes.

  local($pid,$tty,$stat,$time,$name);
  $killlist = `ps xh`;
#  $killlist =~ s/.*\n//;
  $killlist =~ s/\n$//;
  @killarray = split(/\n/,$killlist);
  foreach $i (0..$#killarray) {
    $killarray[$i] =~ s/^\s+(\d)/$1/;
    ($pid,$tty,$stat,$time,$name) = split(/\s+/,$killarray[$i],5);
    $kpid[$i] = $pid;
    $lkill[$i] = "rshkill $kpid[$i]";
    $lkill[$i] = &UrlEncode($lkill[$i]);
    $kname[$i] = $name;
  };
}

sub PrintKill { # Prints the list of "Killable Links."

print '<HTML><HEAD><TITLE> Syrine - Killable links </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> Syrine: Killable Links: </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<P> Your command did not generate any output </P>',"\n";}
  else {
    print '<P> The list below contains links to processes currently running on ',"\n",
    "$HostName",'. Clicking any of these links will TERMINATE (kill) the corresponding process.',"\n",
    '</P><CENTER><HR></CENTER><TABLE>',"\n";
    foreach $i (0..$#kpid) {
      print '<TR><TD NOWRAP><B>',"\n",
      '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=',"$lkill[$i]",'">',"\n",
      '<IMG SRC="',"$SendFilesUrl",'/redball.gif" HSPACE=4 BORDER=0> ! KILL:  ',"$kname[$i]",'</A>',"\n",
      ' [ pid = ',"$kpid[$i]",' ] </B></TD></TR>',"\n";
    };
  };
  print '<TR><TD></TD></TR></TABLE>',"\n";
}

1; # return true