#!/usr/bin/perl -w

$ver='0.2a';
$VerInf = "<SMALL>Syrine $ver, Based on WebRSH 1.1b</Small>";
$! = 0;
# Set error to none.

#-!-!-!> DO NOT MODIFY THIS LINE, AND DO NOT ADD A '#-!-!-!>' ANYWHERE ELSE IN THIS SCRIPT!
#################################################################################################
# The following variables can be configured through Syrine's 'Options' menu item. It is         #
# recommended that you DO NOT make any manual modifications to this part of the script.         #
#################################################################################################

$ProgDir = "$ENV{'DOCUMENT_ROOT'}/cgi-bin";
# Path to Syrine's main directory.

$SendFilesDir = "$ProgDir/sfdir";
# The path to a directory that can be accessed through the server, and is used to place icons.

$SendFilesUrl = "$ENV{'DOCUMENT_ROOT'}/cgi-bin/sfdir";
# URL of $SendFilesDir (The path by which it is recognized by the server).

$HomeDir = "$ENV{'DOCUMENT_ROOT'}";
# The default working directory for Syrine.

$CfgDir = "$ProgDir/cfg";
# A directory in which configuration files are stored.

$TempDir = "$ProgDir/temp";
# A directory to which temporary files are written.

$PlugInDir = "$ProgDir/lib";
# A directory where plugins should reside.

$LocSecurity = 0;
# Setting it to 1 enables location based access restriction. Setting it to 0 disables it.

@AllowAddr = ('127\.0\.0\.1');
# ('a','coma','separated','list','of','IP','patterns','in','qoutes')
# from which access to Syrine is allowed.

@DenyAddr = ();
# Similarly, a list of patterns from which to deny access.

$CheckForAuth = 0;
# If set to 1, the script will varify that some access authentication took place by checking for
# the existence of the environment variable 'AUTH_TYPE'. Setting it to 0 disables this check.

$CheckForUser = 0;
# If set to 1, only users that appear in the @AllowUsers array will be allowed access to Syrine.
# If set to 0, all users (that have been allowed access by the server) will be allowed.

@AllowUsers = ();
# ('a','coma','separated','list','of','user names','in','qoutes') for which access to Syrine
# will be allowed.

$MakeBack = 1;
# If set to 1, a backup copy of the main script will be saved whenever options are changed.
# This backup copy will have the same name as the main script except for a '-' added just
# before the extension. If set to 0, no backup will be done.

$BGColor = '#fffbf0';
# The background color used for Syrine pages.

$BodyParam = '';
# Additional parameters (other than background color) for the BODY tag of Syrine pages.

$TableColor = 'silver';
# The background color used for the outer (framing) tables of Syrine forms.

$FTableParam = 'BORDER=2 CELLSPACING=0 CELLPADDING=1';
# Additional parameters (other than background color) for the outer (framing) tables
# of Syrine forms.

$TableParam = 'BORDER=1 CELLSPACING=0 CELLPADDING=4';
# Parameters for the inner (primary) tables of Syrine forms.

$HostName = 'the remote host';
# The name of the computer running Syrine. This is only used in generating text for some of
# Syrine's documents.

$GetOptions = 'T';
# Determines the kind of "downloadable links" that will be generated (in addition to the usual
# 'GET' links) as part of the  appropriate directory listings. 'B' will generate 'GET as BIN'
# links. 'T' will generate 'GET as TEXT' links. 'BT' will generate both.

$BinText = 1;
# If set to 1, files sent with the 'GET as TEXT' option will be sent in their exact binary
# format (which is the same way they are sent with the 'GET' or 'GET as BIN' options).
# If set to 0, such files will be converted to a non-native text format (namely, LF characters
# will be converted to CR-LF pairs or vice versa). That is, if Syrine is running on UNIX, the
# files will be converted to WinDOS format, and if Syrine is running on Win32, they will be
# converted to UNIX format.

$DefMimeType = 'application/octet-stream';
# Default MIME type to be reported for downloaded files. Only relevant for files with extensions
# that do not appear in Mimetable.txt.

$XPath = 1;
# If set to 1, file names will be added as extra path information whenever files are downloaded
# through one of the 'GET' options. This enables the browser to know the correct filename for
# downloaded files. If set to 0, such extra path information will not be added.

$GCLH = 1;
# If set to 1, the script will supply a 'Content-length' header when a file is dowloaded through
# one of the 'GET' options or when responding to an 'rshtextmode' command. If set to 0, such a
# header will not be provided.

$ReqMeth = 'GET';
# The request method used by most of Syrine's forms.

$AppendToPI = 1;
# Determines whether or not Syrine will append its main form to the output of plugins. The
# plugin itself can always modify $AppendToPI to override the default behavior set here.

$PsLib = 'pslib-linux.pl';
# The name of the library file to supply process related subroutines.

$ComFieldSize = '64';
# Size of the command input field in Syrine's main form.

$FNFieldSize = '56';
# Size of input fields containing filenames in many Syrine forms.

$FMSize = '14';
# Vertical size of the File Manager select field.

$FMHSize = '64';
# Horizontal size of the File Manager select field.

$EdCols = '200';
# Horizontal width (in columns) of the Text Editor window.

$EdRows = '60';
# Vertical width (in rows) of the Text Editor window.

$EdWrap = '';
# Sets the line wrapping option for the Text Editor window. This is only relevant when used with
# suitable browsers (mainly, with Netscape Navigator). Valid options are 'virtual', 'physical',
# and '' (none).

$EdEmptyLnHldr = ' ';
# Added to empty lines when files are opened with the Text Editor. Removed when the Text Editor
# saves a file--if it is the only content of a line. This is used to preserve empty lines in
# text files, since some browsers (notably Lynx) tend to strip them.

$EdOPFL = 1;
# If set to 1, only the first line of files opened with the Text Editor (if it is empty)
# will be protected with the $EdEmptyLnHldr mechanism. If set to 0 and $EdEmptyLnHldr is not
# null, all empty lines will be protected.

$EdHtmlText = 1;
# If set to 1, files opened with the Text Editor will be converted to HTML-formatted text using
# the HtmlText subroutine. If set to 0, such conversion will not take place. An appropriate
# setting here is very important (in particular, to enable editing of HTML files), and depends
# on the browser: Netscape Navigator, Microsoft Internet Explorer, and Lynx require the setting
# to be 1. Other browsers (e.g., NCSA Mosaic 3.0) may require it to be 0.

$EdTAMod = '/';
# This will be added to follow the first '<' in any </TEXTAREA> tag when files are opened with
# the Text Editor. It will be removed from such tags when the Text Editor saves a file. This
# mechanism enables editing of HTML files containing </TEXTAREA> tags with browsers that require
# $EdHtmlText to be set to 0. It is active only if $EdHtmlText is set to 0.

$UseWin32Console = 0;
# This only comes into play on Win32 platforms. If set to 1, Syrine assumes it can communicate
# with programs executed by it using STDIN/STDOUT, which requires Syrine itself to be executed
# with a full console. If set to 0, this is not assumed, and Syrine will obtain output of other
# programs by redirecting it to a temporary file and reading it from there. It should be set to
# 1 if and only if Syrine is being executed with a full console (this is determined by the
# executing web server).

$LoginShell = 1;
# This only comes into play on UNIX platforms. If set to 1, Syrine will do its best to emulate
# the user's login environment. It will try to get the user's login shell and home directory
# from the system, and will try to get the proper default umask (by extracting it from a shell)
# whenever files are created. Furthermore, if the user's login shell supports being run as a
# non-interactive login shell (namely, if it is either bash, ksh, or zsh), commands will be
# executed through a login shell. If set to 0, such initialization would not take place, and
# it may be needed to manually set the proper umask and some environment variables below.

$ColFilter = 1;
# This only comes into play on UNIX platforms. If set to 1, output from shell commands will be
# filtered through 'col' to remove control characters (this is important to make things like
# 'man *' work properly). If set to 0, such filtering would not take place and Syrine will
# present the raw STDOUT output of commands. It is recommended to set this to 1 as long as
# you have 'col'. This setting does not effect the 'rshtextmode' command which always provides
# raw STDOUT output.

#-!-!-!> DO NOT MODIFY THIS LINE, AND DO NOT ADD A '#-!-!-!>' ANYWHERE ELSE IN THIS SCRIPT!
#################################################################################################
# The following variables can be optionally configured. Do not change them without reason.      #
#################################################################################################

$BufSize = 32768;
# The default size (in bytes) for buffers.

$OStype = '';
# The operating system in use (either 'w95', 'wNT' or 'U'). If left null, the script should
# find it out by itself.

$ScriptUrl = $ENV{'SCRIPT_NAME'};
# URL of this script (The path by which it is recognized by the server).

umask 066;
# The default umask for the Syrine process. This only comes into play on UNIX platforms and
# probably only when $LoginShell is set to 0. Comment it out to preserve a previous umask.


if ($ENV{'PATH_INFO'} =~ m/^(|$ScriptUrl)\/rshplugin\/(\w*)(\/.*|)\:\:\/(.+)$/)
{ # If a plugin is called, call it.

	($PrePathInfo,$rshId,$rshPWD,$rshPlugIn) = ($1,$2,$3,$4);
	$rshplPWD = &UrlEncode($rshPWD);
	$rshplPWD =~ s/%2F/\//g;
	if ($Win32) {
		$rshPWD =~ s/^\///;
		$rshPWD =~ s/\//\\/g;
	};
	$rshlPWD = &UrlEncode($rshPWD);
	if ($rshPlugIn =~ m/^([^\/]+)(\/.*)$/) {
		$rshPlugIn = $1;
		$rshPathInfo = $2;
	} else {
		$rshPathInfo = '';
	};
	if (!$PrePathInfo) {
		$ENV{'PATH_INFO'} = $rshPathInfo;
		if ($ENV{'PATH_INFO'}) {
			if ($ENV{'PATH_TRANSLATED'} =~ m/^(.*)([\\\/])rshplugin([\\\/])$rshId/) {
				local($ServRoot,$Slash) = ($1,$3);
				$rshPathInfo =~ s/\//$Slash/g if ($Slash ne '/');
				$ENV{'PATH_TRANSLATED'} = "$ServRoot$rshPathInfo";
			} else {
				$ENV{'PATH_TRANSLATED'} = ''; delete $ENV{'PATH_TRANSLATED'};
			};
		} else {
			delete $ENV{'PATH_INFO'};
			$ENV{'PATH_TRANSLATED'} = ''; delete $ENV{'PATH_TRANSLATED'};
		};
	};
	$ENV{'SCRIPT_NAME'} = "$ScriptUrl/rshplugin/$rshId$rshplPWD\%3A\%3A/$rshPlugIn";
	if ($rshPlugIn =~ s/^LibPI//) {
		$rshPlugIn = "$ProgDir/lib/$rshPlugIn";
	} else {
		&ChangeDir("$PlugInDir") || &SyrineDie("Can\'t change working directory to $PlugInDir \: $!");
		$0 = "$PlugInDir/$rshPlugIn";
	};
	(-f $rshPlugIn && -r _) || &SyrineDie("Can\'t access the plugin $rshPlugIn \: $!");
	require "$rshPlugIn";
	select STDOUT;
	if ($AppendToPI) {
		print "\n";
		($id,$pwd,$lpwd,$plpwd) = ($rshId,$rshPWD,$rshlPWD,$rshplPWD);
		print '</BODY></HTML>',"\n";
	};

} else { # Otherwise, run Syrine.


	require "$ProgDir/lib/cgi-lib.pl" ||
		&SyrineDie("Can\'t require cgi-lib\.pl \: $!");

	# Reset some cgi-lib parameters
	$cgi_lib'maxdata =  1073741824;      # maximum bytes to accept via POST
	$cgi_lib'writefiles = $TempDir;      # temporary directory to which to write files
	$cgi_lib'bufsize  =  $BufSize;       # default buffer size when reading multipart

	unless ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
		&ReadParse(*input);
	} else {
		&GetUmask if ($OStype eq 'U');
		&ReadParse(*input,*CFileName,*CContType,*TFileName);
		&SyrineDie("khaled") unless ($TFileName{'upfile'});
	};

	$pwd = $input{'pwd'};
	$com = 'rshupload';
	&GetInidat;
	if ($pwd) {
		&ChangeDir($pwd) || &SyrineDie("Can\'t change working directory to $pwd \: $!");
	} else {
		&ChangeDir($HomeDir) || &SyrineDie("Can\'t change working directory to $HomeDir \: $!");
	};
	$id = $input{'id'};
	$id =~ y/0-9//d;
	$id = "$id$counter";

	if ($com) {		# We sacrifice our own STDERR and pipe it to a handle we can read. Then we
					# execute our command, read STDERR, and append whatever we find there in
					# front of our output.

		pipe(SHELLERR,ERRPIPE); select(ERRPIPE); $| = 1;
		open(STDERR,">&ERRPIPE"); close(ERRPIPE);
		select(STDERR); $| = 1; select(STDOUT); # $| = 1;
		&DoCom;
		close(STDERR); local($err,$buf) = ('','');
		while (read(SHELLERR,$buf,$BufSize)) {
			$err .= $buf;
		};
		if ($err && $output eq 'ok') {
			$output = $err;
		} else {
			$output = join('',$err,$output);
		};
	};
	&PrintHTTPHeaders;
	&PrintHTMLHead;
	print $output;
};

#################################################################################################
# Main subroutines:


sub GetInidat { # Gets the current $counter and file-manager information.

	open(INIDAT, "<$CfgDir/rshinidat.txt");
	$counter = <INIDAT>; chop($counter);
	$counter = $counter+1;
	$clip = <INIDAT>;
	close(INIDAT);
}

sub DoCom { # Executes the command $com.

	$com =~ s/[\r\n]//;
	($mcom, $pcom) = split(/\s+/,$com,2);
   	require "$ProgDir/lib/upldlib.pl" || &SyrineDie("Can\'t require upldlib\.pl \: $!"); 
	&DoUpload;
}

sub SyrineDie { # Sends an error message and terminates execution of Syrine.

	local(@msg) = @_;
	local($i);
	&PrintHTTPHeaders;
	unless (@msg) {@msg = "Syrine encountered a fatal error\n"};
	print '<HTML><HEAD><TITLE> Execution Aborted </TITLE></HEAD><BODY><H2>',"\n",
	"$msg[0]",'</H2>',"\n";
	foreach $i (1 .. $#msg) {print '<P>',"$msg[$i]",'</P>',"\n";};
	print '<HR></BODY></HTML>',"\n";
	die @msg;
}


#################################################################################################
# Secondary subroutines ("utilities"):

sub ExUShellCom { # Executes a UNIX shell command and optionally returns its output.

	local($Com,$LoginShell,$ColFilter,$Wait) = @_;
	local($shell) = $ENV{'SHELL'};
	$shell = '/bin/sh' unless ($shell);
	local($logsw,$colflt,$output) = ('','','');
	if ($LoginShell) {
		if ($shell =~ m/bash$/) {
		$logsw = ' -login';
		} elsif ($shell =~ m/ksh$/ || $shell =~ m/zsh$/) {
			$logsw = ' -l';
		};
	};
	$colflt = ' | col -bx' if ($ColFilter); #Filter to remove control characters.
	$Com =~ s/\"/\\\"/g;
	if ($Wait) {
		$output = `$shell$logsw -c \"$Com\"$colflt`;
#	Example:    /bin/bash -login -c "ls -l" | col -bx
	} else {
		if ($shell =~ m/csh$/) {
			open(PIPE,"$shell$logsw -c \"$Com \>\& /dev/null \&\"|");
		} else {
			open(PIPE,"$shell$logsw -c \"$Com \> /dev/null 2\>\&1 \&\"|");
#			Example:   /bin/bash -login -c "ls -l > /dev/null 2>&1 &"|
#			open(PIPE,"$shell$logsw -c \"$Com &\> /dev/null \&\"|");
		};
		close(PIPE);
	};
	return $output;
}

sub GetUmask { # Sets Syrine's umask to correspond to the shell's umask.

	local($umask) = &ExUShellCom('umask',$LoginShell,0,1);
	$umask =~ s/\n$//;
	$umask = join('','0',$umask);
	umask oct($umask);
}

sub ChangeDir { # Changes the working directory.

	local($dir) = @_;
	&SyrineDie("$dir is not a valid directory\!") if ($dir =~ m/^[\\\/][\\\/]/);
	$dir = "$dir\\" if ($dir =~ m/^\w\:$/ && $Win32);
	$dir = $ENV{'HOME'} if ($dir eq '~' && $ENV{'HOME'} && $OStype eq 'U');
	chdir $dir;
}

sub HtmlText { # Converts plain text to a format suitable for embedding in HTML.

	local($text) = @_;
	$text =~ s/\&/\&amp\;/g;
	$text =~ s/\</\&lt\;/g;
	$text =~ s/\>/\&gt\;/g;
	$text =~ s/\"/\&quot\;/g;
	return $text;
}

sub UrlChar { # Url-encodes a character (assumes characters above 0F).

	local($char) = @_;
	$char = join('','%',sprintf("%lx",unpack("c",$char)));
	$char =~ y/a-z/A-Z/;
	return $char;
}

sub UrlEncode { # Returns a url-encoded string (does not encode 00-0F control characters).

	local($string) = @_;
	$string =~ s/\%/\%25/g;
#	$string =~ s/\+/\%2B/g;
#	$string =~ s/ /\+/g;
#	$string =~ s/[^\x00-\x0f\!\"\$\%\'\(\)\*\+\-\.\w]/&UrlChar($&)/ge;
	$string =~ s/([^\x00-\x0f\!\"\$\%\'\(\)\*\-\.\w])/&UrlChar($1)/ge;
	return $string;
}

sub FullPath { # Returns the full path name for a file in a directory.

	local($directory,$file) = @_;
	local($path);
	if ($directory =~ m/[\\\/]$/) {
		$path = "$directory$file";
	} else {
		if ($Win32) {
			$path = "$directory\\$file";
		} else {
			$path = "$directory/$file";
		};
	};
	return $path;
}

sub FileName { # Extracts the name of the file from its full path name.

	local($name) = @_;
	$name =~ s/\\/\//g; 
	$name =~ s/(\W)/\\$1/g;
	$name =~ m/([^\/]+)$/;
	$name = $1;
	$name =~ s/\\//g;
	return $name;
}

sub DirName { # Extracts the name of the directory from the full path name of a file.

	local($name) = @_;
	$name =~ s/\\/\//g; 
	$name =~ s/(\W)/\\$1/g;
	$name =~ m/^(.+)\/([^\/]+)$/;
	$name = $1;
	$name =~ s/\\//g;
	$name =~ s/\//\\/g if ($Win32);
	return $name;
}

sub FileExt { # Returns the (capitalized) extension of a filename.

	local($filename) = @_;
	$filename =~ m/(\.[^\.]*$)/;
	local($ext) = $1;
	$ext =~ y/a-z/A-Z/;
	return $ext;
}
  
sub GetDirList { # Creates two arrays (a plain version and an url-encoded one) each of which   
                 # contains the list of directories in the current working directory. The 
                 # creation of the url-encoded array is suppressed if the function gets a
                 # true valued parameter.

	local($NoUrlEn) = @_;
	opendir(DIR,'.');
	@dirarray = sort grep -d && !/^\.\.?$/, readdir DIR;
	close DIR;
	unless ($NoUrlEn) {
		foreach $i (0..$#dirarray) {
			$ldirarray[$i] = &UrlEncode($dirarray[$i]);
		};
	};
}

sub GetFileList { # Creates two arrays (a plain version and an url-encoded one) each of which   
                  # contains the list of files in the current working directory. The creation
                  # of the url-encoded array is suppressed if the function gets a true valued
                  # parameter.

	local($NoUrlEn) = @_;
	opendir(DIR,'.');
	@filearray = sort grep -f, readdir DIR;
	close DIR;
	unless ($NoUrlEn) {
		foreach $i (0..$#filearray) {
			$lfilearray[$i] = &UrlEncode($filearray[$i]);
		};
	};
}

sub ParseHTM { # Gets a text string as a parameter, replaces certain text constructs with
               # current values of appropriate Syrine variables, and returns the result.

	local($output) = @_;
	$output =~ s/<\!\$BGColor\!>/$BGColor/g;
	$output =~ s/<\!\$BodyParam\!>/$BodyParam/g;
	$output =~ s/<\!\$TableColor\!>/$TableColor/g;
	$output =~ s/<\!\$FTableParam\!>/$FTableParam/g;
	$output =~ s/<\!\$TableParam\!>/$TableParam/g;
	$output =~ s/<\!\$ScriptUrl\!>/$ScriptUrl/g;
	$output =~ s/<\!\$SendFilesUrl\!>/$SendFilesUrl/g;
	$output =~ s/<\!\$counter\!>/$counter/g;
	$output =~ s/<\!\$id\!>/$id/g;
	$output =~ s/<\!\$lpwd\!>/$lpwd/g;
	$output =~ s/<\!\$plpwd\!>/$plpwd/g;
	return $output;
}

sub ContType { # Returns the MIME Content-type of a file based on its extension (according
               # to the correspondence set in the file Mimetable.txt).

	local($filename) = @_;
	local($ext,$cont,$fext,$fcont,$buf,*mtable);
	$fext = &FileExt($filename);
	open(MTABLE,"<$CfgDir/mimetable.txt") || &SyrineDie("Can\'t open MIME table: $!");
	while (read(MTABLE,$buf,$BufSize)) {
		$mtable .= $buf;
	};
	close(MTABLE);
	@mtable = split(/\n/,$mtable);
	local($i) = 0;
	while (!$fcont && $i <= $#mtable) {
		($ext,$cont) = split(/\s+/,$mtable[$i],2);
		if ($ext eq $fext) {$fcont = $cont;};
		$i++;
	};
	unless ($fcont) {$fcont = $DefMimeType;};
	return $fcont;
}


#################################################################################################
# Subroutines to print html output:

sub PrintHTTPHeaders{
	print "X-Generatot: Syrine $ver\n";
	print "Content-type: text/html; charset=windows-1256;\n";
	print "\n";
};

sub PrintHTMLHead{
	print "<HTML>\n<HEAD>\n<TITLE>Syrine $ver</TITLE>\n",
	"<META Name=Generator Content=\"Syrine $ver\">\n",
	'</HEAD>',"\n",
	'<BODY bgcolor="',"$BGColor\" $BodyParam",'>',"\n",
	"<CENTER><H1> Syrine $ver </H1></CENTER>","\n","\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
};


# The following lines exist only to avoid warning messages

$SendFilesDir       =  $SendFilesDir;
$SendFilesUrl       =  $SendFilesUrl;
$MakeBack           =  $MakeBack;
$GetOptions         =  $GetOptions;
$FNFieldSize        =  $FNFieldSize;
$XPath              =  $XPath;
$FMSize             =  $FMSize;
$FMHSize            =  $FMHSize;
$EdCols             =  $EdCols;
$EdRows             =  $EdRows;
$EdWrap             =  $EdWrap;
$EdEmptyLnHldr      =  $EdEmptyLnHldr;
$EdTAMod            =  $EdTAMod;
$EdOPFL             =  $EdOPFL;
$EdHtmlText         =  $EdHtmlText;
$cgi_lib'writefiles =  $cgi_lib'writefiles;
$cgi_lib'bufsize    =  $cgi_lib'bufsize ;
$cgi_lib'maxdata    =  $cgi_lib'maxdata;
$CFileName          =  $CFileName;
$CContType          =  $CContType;
$lfilearray         =  $lfilearray;
$ldirarray          =  $ldirarray;

1; #return true 
